# NOMS -- A web-app for Armagetron Advanced statistics
# Copyright (C) 2009  Daniel Harple
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation in version 3 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

require "rubygems"

gem("builder", ">= 2.1.2")
gem("json", ">= 1.1.2")
gem("rack-cache", ">= 0.5.2")
gem("sequel", ">= 3.4.0")
gem("sinatra", ">= 0.9.4")

require "noms/config"
require "noms/choropleth"
require "noms/country_code"
require "noms/setup"
require "noms/ladderlog"
require "noms/models/generator"
require "noms/stat_file"
require "noms/web_app"
require "noms/web_app/stats_table"
require "noms/web_app/stat_signature"
require "noms/armaskill"
require "noms/achievement"
require "noms/util"
