# NOMS -- A web-app for Armagetron Advanced statistics
# Copyright (C) 2010  Daniel Harple
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation in version 3 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

require "yaml"

module NOMS
  module CountryCode
    
    COUNTRY_NAMES = File.open(File.join(File.dirname(__FILE__), "country_codes.txt")) { |f| YAML.load(f) }
    
    def self.country_name_from_alpha2(a2)
      COUNTRY_NAMES[a2]
    end
    
    def self.all_alpha2_codes
      COUNTRY_NAMES.keys
    end
  end
end
