# NOMS -- A web-app for Armagetron Advanced statistics
# Copyright (C) 2010  Daniel Harple
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation in version 3 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

module NOMS
  module Choropleth
    class Entry < Sequel::Model
      def self.find_country(ip)
        n = convert_ip(ip)
        find((:ip_from <= n) & (:ip_to >= n))
      end
      
      def self.lookup_ip(ip)
        @cache ||= {}
        return @cache[ip] if @cache.has_key?(ip)
        
        entry = find_country(ip)
        @cache[ip] = entry
        return entry
      end
  
      private
  
      def self.convert_ip(ip)
        ip.split(".").inject(0) { |memo, part| (memo << 8) + part.to_i }
      end      
    end
  end
end
