// Copyright (c) 2010, Daniel Harple

$(document).ready(function () {
    var map = new WorldMap("world-map");
});

var WorldMap = function(node)
{
    this.canvas = Raphael(node, 939, 531, 0, 0);
    var self = this;
    $.getJSON(WorldMap.world_map_players_link(), function(counts) {
        $.getJSON("/world-map.json", function(countries) { WorldMap.setup_countries(self, countries, counts); });
    });
};

WorldMap.prototype.setup_events = function()
{
    for (var index in this.countries) {
        var country = this.countries[index];
        for (var element_index in country["elements"]) {
            (function(canvas, country, element) {
                $(element.node).mouseover(function(event) {
                    if (country["count"] == 0)
                        return;
                        
                    if (country["text"])
                    {
                        // country["flag_element"].show();
                        country["text"].show();
                    }
                    else
                    {
                        
                        // country["flag_element"] = canvas.image(country["flag"], 463, 450, 16, 11);
                        country["text"] = canvas.text(470, 485, country["name"] + "\n" + country["count"] + " " + WorldMap.pluralize(country["count"], "player", "players"));
                        country["text"].attr("font-size", "18px");
                    }
                    canvas.safari();
                });
                
                $(element.node).mouseleave(function(event) {
                    if (country["count"] == 0)
                        return;
                    // country["flag_element"].hide();
                    country["text"].hide();
                    canvas.safari();
                });
            })(this.canvas, country, country["elements"][element_index]);
        }
    }
};

WorldMap.setup_countries = function(map, countries, counts)
{
    for (var index in countries) {
        var country = countries[index];
        
        var count = counts[country["id"]];
        if (count)
        {
            country["count"] = count["count"];
            country["color"] = count["color"];
            country["name"] = count["name"];
            country["flag"] = count["flag"];
        }
        else
        {
            country["count"] = 0;
            country["color"] = "#444444";
            country["name"] = "";
            country["flag"] = "";
        }
        
        var set = map.canvas.set();
        var elements = [];
        
        for (var path_index in country["paths"]) {
            var element = map.canvas.path(country["paths"][path_index]);
            element.attr({fill:country["color"], stroke:"none"});
            set.push(element);
            elements.push(element);
        }
        
        country["set"] = set;
        country["elements"] = elements;
    }
    
    map.countries = countries;
    map.setup_events();
};

WorldMap.world_map_players_link = function()
{
    var location = window.location.pathname.replace(/([^\/]+)\/?/, "$1/world-map-players.json");
    return "http://" + window.location.host + location;
};

WorldMap.pluralize = function(n, singular, plural)
{
    if (n == 1)
        return singular;
    return plural;
};
